/*
sp_GenerateClass
	@namespace			= 'NormalTests.AdventureWorks', 
	@column_has_prefix	= 0
 */
using System;
using Normal;

namespace TestWinformHelper
{
    [Serializable]
    [Table(TableName = "dbo.AWBuildVersion")]
    public class Awbuildversion
    {
        private Int16 _systeminformationid;
        private string _databaseversion;
        private DateTime _versiondate;
        private DateTime _modifieddate;

        [Id(Name = "SystemInformationID")]
        public Int16 Systeminformationid
        {
            get { return _systeminformationid; }
            set { _systeminformationid = value; }
        }

        [Column(Name = "Database Version", Required = true)]
        public string Databaseversion
        {
            get { return _databaseversion; }
            set { _databaseversion = value; }
        }

        [Column(Name = "VersionDate", Required = true)]
        public DateTime Versiondate
        {
            get { return _versiondate; }
            set { _versiondate = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "dbo.DatabaseLog")]
    public class Databaselog
    {
        private Int32 _databaselogid;
        private DateTime _posttime;
        private string _databaseuser;
        private string _event;
        private string _schema;
        private string _object;
        private string _tsql;
        private string _xmlevent;

        [Id(Name = "DatabaseLogID")]
        public Int32 Databaselogid
        {
            get { return _databaselogid; }
            set { _databaselogid = value; }
        }

        [Column(Name = "PostTime", Required = true)]
        public DateTime Posttime
        {
            get { return _posttime; }
            set { _posttime = value; }
        }

        [Column(Name = "DatabaseUser", Required = true)]
        public string Databaseuser
        {
            get { return _databaseuser; }
            set { _databaseuser = value; }
        }

        [Column(Name = "Event", Required = true)]
        public string Event
        {
            get { return _event; }
            set { _event = value; }
        }

        [Column(Name = "Schema", Required = false)]
        public string Schema
        {
            get { return _schema; }
            set { _schema = value; }
        }

        [Column(Name = "Object", Required = false)]
        public string Object
        {
            get { return _object; }
            set { _object = value; }
        }

        [Column(Name = "TSQL", Required = true)]
        public string Tsql
        {
            get { return _tsql; }
            set { _tsql = value; }
        }

        [Column(Name = "XmlEvent", Required = true)]
        public string Xmlevent
        {
            get { return _xmlevent; }
            set { _xmlevent = value; }
        }

    }
    [Serializable]
    [Table(TableName = "dbo.ErrorLog")]
    public class Errorlog
    {
        private Int32 _errorlogid;
        private DateTime _errortime;
        private string _username;
        private Int32 _errornumber;
        private Int32? _errorseverity;
        private Int32? _errorstate;
        private string _errorprocedure;
        private Int32? _errorline;
        private string _errormessage;

        [Id(Name = "ErrorLogID")]
        public Int32 Errorlogid
        {
            get { return _errorlogid; }
            set { _errorlogid = value; }
        }

        [Column(Name = "ErrorTime", Required = true)]
        public DateTime Errortime
        {
            get { return _errortime; }
            set { _errortime = value; }
        }

        [Column(Name = "UserName", Required = true)]
        public string Username
        {
            get { return _username; }
            set { _username = value; }
        }

        [Column(Name = "ErrorNumber", Required = true)]
        public Int32 Errornumber
        {
            get { return _errornumber; }
            set { _errornumber = value; }
        }

        [Column(Name = "ErrorSeverity", Required = false)]
        public Int32? Errorseverity
        {
            get { return _errorseverity; }
            set { _errorseverity = value; }
        }

        [Column(Name = "ErrorState", Required = false)]
        public Int32? Errorstate
        {
            get { return _errorstate; }
            set { _errorstate = value; }
        }

        [Column(Name = "ErrorProcedure", Required = false)]
        public string Errorprocedure
        {
            get { return _errorprocedure; }
            set { _errorprocedure = value; }
        }

        [Column(Name = "ErrorLine", Required = false)]
        public Int32? Errorline
        {
            get { return _errorline; }
            set { _errorline = value; }
        }

        [Column(Name = "ErrorMessage", Required = true)]
        public string Errormessage
        {
            get { return _errormessage; }
            set { _errormessage = value; }
        }

    }
    [Serializable]
    [Table(TableName = "HumanResources.Department")]
    public class Department
    {
        private Int16 _departmentid;
        private string _name;
        private string _groupname;
        private DateTime _modifieddate;

        [Id(Name = "DepartmentID")]
        public Int16 Departmentid
        {
            get { return _departmentid; }
            set { _departmentid = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Column(Name = "GroupName", Required = true)]
        public string Groupname
        {
            get { return _groupname; }
            set { _groupname = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "HumanResources.Employee")]
    public class Employee
    {
        private Int32 _employeeid;
        private string _nationalidnumber;
        private Int32 _contactid;
        private string _loginid;
        private Int32? _managerid;
        private string _title;
        private DateTime _birthdate;
        private string _maritalstatus;
        private string _gender;
        private DateTime _hiredate;
        private bool _salariedflag;
        private Int16 _vacationhours;
        private Int16 _sickleavehours;
        private bool _currentflag;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "EmployeeID")]
        public Int32 Employeeid
        {
            get { return _employeeid; }
            set { _employeeid = value; }
        }

        [Id(Name = "NationalIDNumber")]
        public string Nationalidnumber
        {
            get { return _nationalidnumber; }
            set { _nationalidnumber = value; }
        }

        [Column(Name = "ContactID", Required = true)]
        public Int32 Contactid
        {
            get { return _contactid; }
            set { _contactid = value; }
        }

        [Id(Name = "LoginID")]
        public string Loginid
        {
            get { return _loginid; }
            set { _loginid = value; }
        }

        [Id(Name = "ManagerID")]
        public Int32? Managerid
        {
            get { return _managerid; }
            set { _managerid = value; }
        }

        [Column(Name = "Title", Required = true)]
        public string Title
        {
            get { return _title; }
            set { _title = value; }
        }

        [Column(Name = "BirthDate", Required = true)]
        public DateTime Birthdate
        {
            get { return _birthdate; }
            set { _birthdate = value; }
        }

        [Column(Name = "MaritalStatus", Required = true)]
        public string Maritalstatus
        {
            get { return _maritalstatus; }
            set { _maritalstatus = value; }
        }

        [Column(Name = "Gender", Required = true)]
        public string Gender
        {
            get { return _gender; }
            set { _gender = value; }
        }

        [Column(Name = "HireDate", Required = true)]
        public DateTime Hiredate
        {
            get { return _hiredate; }
            set { _hiredate = value; }
        }

        [Column(Name = "SalariedFlag", Required = true)]
        public bool Salariedflag
        {
            get { return _salariedflag; }
            set { _salariedflag = value; }
        }

        [Column(Name = "VacationHours", Required = true)]
        public Int16 Vacationhours
        {
            get { return _vacationhours; }
            set { _vacationhours = value; }
        }

        [Column(Name = "SickLeaveHours", Required = true)]
        public Int16 Sickleavehours
        {
            get { return _sickleavehours; }
            set { _sickleavehours = value; }
        }

        [Column(Name = "CurrentFlag", Required = true)]
        public bool Currentflag
        {
            get { return _currentflag; }
            set { _currentflag = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "HumanResources.EmployeeAddress")]
    public class Employeeaddress
    {
        private Int32 _employeeid;
        private Int32 _addressid;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "EmployeeID")]
        public Int32 Employeeid
        {
            get { return _employeeid; }
            set { _employeeid = value; }
        }

        [Id(Name = "AddressID")]
        public Int32 Addressid
        {
            get { return _addressid; }
            set { _addressid = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "HumanResources.EmployeeDepartmentHistory")]
    public class Employeedepartmenthistory
    {
        private Int32 _employeeid;
        private Int16 _departmentid;
        private Int16 _shiftid;
        private DateTime _startdate;
        private DateTime? _enddate;
        private DateTime _modifieddate;

        [Id(Name = "EmployeeID")]
        public Int32 Employeeid
        {
            get { return _employeeid; }
            set { _employeeid = value; }
        }

        [Id(Name = "DepartmentID")]
        public Int16 Departmentid
        {
            get { return _departmentid; }
            set { _departmentid = value; }
        }

        [Id(Name = "ShiftID")]
        public Int16 Shiftid
        {
            get { return _shiftid; }
            set { _shiftid = value; }
        }

        [Id(Name = "StartDate")]
        public DateTime Startdate
        {
            get { return _startdate; }
            set { _startdate = value; }
        }

        [Column(Name = "EndDate", Required = false)]
        public DateTime? Enddate
        {
            get { return _enddate; }
            set { _enddate = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "HumanResources.EmployeePayHistory")]
    public class Employeepayhistory
    {
        private Int32 _employeeid;
        private DateTime _ratechangedate;
        private decimal _rate;
        private Int16 _payfrequency;
        private DateTime _modifieddate;

        [Id(Name = "EmployeeID")]
        public Int32 Employeeid
        {
            get { return _employeeid; }
            set { _employeeid = value; }
        }

        [Id(Name = "RateChangeDate")]
        public DateTime Ratechangedate
        {
            get { return _ratechangedate; }
            set { _ratechangedate = value; }
        }

        [Column(Name = "Rate", Required = true)]
        public decimal Rate
        {
            get { return _rate; }
            set { _rate = value; }
        }

        [Column(Name = "PayFrequency", Required = true)]
        public Int16 Payfrequency
        {
            get { return _payfrequency; }
            set { _payfrequency = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "HumanResources.JobCandidate")]
    public class Jobcandidate
    {
        private Int32 _jobcandidateid;
        private Int32? _employeeid;
        private string _resume;
        private DateTime _modifieddate;

        [Id(Name = "JobCandidateID")]
        public Int32 Jobcandidateid
        {
            get { return _jobcandidateid; }
            set { _jobcandidateid = value; }
        }

        [Id(Name = "EmployeeID")]
        public Int32? Employeeid
        {
            get { return _employeeid; }
            set { _employeeid = value; }
        }

        [Column(Name = "Resume", Required = false)]
        public string Resume
        {
            get { return _resume; }
            set { _resume = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "HumanResources.Shift")]
    public class Shift
    {
        private Int16 _shiftid;
        private string _name;
        private DateTime _starttime;
        private DateTime _endtime;
        private DateTime _modifieddate;

        [Id(Name = "ShiftID")]
        public Int16 Shiftid
        {
            get { return _shiftid; }
            set { _shiftid = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Id(Name = "StartTime")]
        public DateTime Starttime
        {
            get { return _starttime; }
            set { _starttime = value; }
        }

        [Id(Name = "EndTime")]
        public DateTime Endtime
        {
            get { return _endtime; }
            set { _endtime = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Person.Address")]
    public class Address
    {
        private Int32 _addressid;
        private string _addressline1;
        private string _addressline2;
        private string _city;
        private Int32 _stateprovinceid;
        private string _postalcode;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "AddressID")]
        public Int32 Addressid
        {
            get { return _addressid; }
            set { _addressid = value; }
        }

        [Id(Name = "AddressLine1")]
        public string Addressline1
        {
            get { return _addressline1; }
            set { _addressline1 = value; }
        }

        [Id(Name = "AddressLine2")]
        public string Addressline2
        {
            get { return _addressline2; }
            set { _addressline2 = value; }
        }

        [Id(Name = "City")]
        public string City
        {
            get { return _city; }
            set { _city = value; }
        }

        [Id(Name = "StateProvinceID")]
        public Int32 Stateprovinceid
        {
            get { return _stateprovinceid; }
            set { _stateprovinceid = value; }
        }

        [Id(Name = "PostalCode")]
        public string Postalcode
        {
            get { return _postalcode; }
            set { _postalcode = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Person.AddressType")]
    public class Addresstype
    {
        private Int32 _addresstypeid;
        private string _name;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "AddressTypeID")]
        public Int32 Addresstypeid
        {
            get { return _addresstypeid; }
            set { _addresstypeid = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Person.Contact")]
    public class Contact
    {
        private Int32 _contactid;
        private bool _namestyle;
        private string _title;
        private string _firstname;
        private string _middlename;
        private string _lastname;
        private string _suffix;
        private string _emailaddress;
        private Int32 _emailpromotion;
        private string _phone;
        private string _passwordhash;
        private string _passwordsalt;
        private string _additionalcontactinfo;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "ContactID")]
        public Int32 ContactID
        {
            get { return _contactid; }
            set { _contactid = value; }
        }

        [Column(Name = "NameStyle", Required = true)]
        public bool NameStyle
        {
            get { return _namestyle; }
            set { _namestyle = value; }
        }

        [Column(Name = "Title", Required = false)]
        public string Title
        {
            get { return _title; }
            set { _title = value; }
        }

        [Column(Name = "FirstName", Required = true)]
        public string FirstName
        {
            get { return _firstname; }
            set { _firstname = value; }
        }

        [Column(Name = "MiddleName", Required = false)]
        public string MiddleName
        {
            get { return _middlename; }
            set { _middlename = value; }
        }

        [Column(Name = "LastName", Required = true)]
        public string LastName
        {
            get { return _lastname; }
            set { _lastname = value; }
        }

        [Column(Name = "Suffix", Required = false)]
        public string Suffix
        {
            get { return _suffix; }
            set { _suffix = value; }
        }

        [Id(Name = "EmailAddress")]
        public string EmailAddress
        {
            get { return _emailaddress; }
            set { _emailaddress = value; }
        }

        [Column(Name = "EmailPromotion", Required = true)]
        public Int32 EmailPromotion
        {
            get { return _emailpromotion; }
            set { _emailpromotion = value; }
        }

        [Column(Name = "Phone", Required = false)]
        public string Phone
        {
            get { return _phone; }
            set { _phone = value; }
        }

        [Column(Name = "PasswordHash", Required = true)]
        public string PasswordHash
        {
            get { return _passwordhash; }
            set { _passwordhash = value; }
        }

        [Column(Name = "PasswordSalt", Required = true)]
        public string PasswordSalt
        {
            get { return _passwordsalt; }
            set { _passwordsalt = value; }
        }

        [Column(Name = "AdditionalContactInfo", Required = false)]
        public string AdditionalContactInfo
        {
            get { return _additionalcontactinfo; }
            set { _additionalcontactinfo = value; }
        }

        [Column(Name = "rowguid", Required = false)]
        public object rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime ModifiedDate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Person.ContactType")]
    public class Contacttype
    {
        private Int32 _contacttypeid;
        private string _name;
        private DateTime _modifieddate;

        [Id(Name = "ContactTypeID")]
        public Int32 Contacttypeid
        {
            get { return _contacttypeid; }
            set { _contacttypeid = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Person.CountryRegion")]
    public class Countryregion
    {
        private string _countryregioncode;
        private string _name;
        private DateTime _modifieddate;

        [Id(Name = "CountryRegionCode")]
        public string Countryregioncode
        {
            get { return _countryregioncode; }
            set { _countryregioncode = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Person.StateProvince")]
    public class Stateprovince
    {
        private Int32 _stateprovinceid;
        private string _stateprovincecode;
        private string _countryregioncode;
        private bool _isonlystateprovinceflag;
        private string _name;
        private Int32 _territoryid;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "StateProvinceID")]
        public Int32 Stateprovinceid
        {
            get { return _stateprovinceid; }
            set { _stateprovinceid = value; }
        }

        [Id(Name = "StateProvinceCode")]
        public string Stateprovincecode
        {
            get { return _stateprovincecode; }
            set { _stateprovincecode = value; }
        }

        [Id(Name = "CountryRegionCode")]
        public string Countryregioncode
        {
            get { return _countryregioncode; }
            set { _countryregioncode = value; }
        }

        [Column(Name = "IsOnlyStateProvinceFlag", Required = true)]
        public bool Isonlystateprovinceflag
        {
            get { return _isonlystateprovinceflag; }
            set { _isonlystateprovinceflag = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Column(Name = "TerritoryID", Required = true)]
        public Int32 Territoryid
        {
            get { return _territoryid; }
            set { _territoryid = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.BillOfMaterials")]
    public class Billofmaterials
    {
        private Int32 _billofmaterialsid;
        private Int32? _productassemblyid;
        private Int32 _componentid;
        private DateTime _startdate;
        private DateTime? _enddate;
        private string _unitmeasurecode;
        private Int16 _bomlevel;
        private decimal _perassemblyqty;
        private DateTime _modifieddate;

        [Id(Name = "BillOfMaterialsID")]
        public Int32 Billofmaterialsid
        {
            get { return _billofmaterialsid; }
            set { _billofmaterialsid = value; }
        }

        [Id(Name = "ProductAssemblyID")]
        public Int32? Productassemblyid
        {
            get { return _productassemblyid; }
            set { _productassemblyid = value; }
        }

        [Id(Name = "ComponentID")]
        public Int32 Componentid
        {
            get { return _componentid; }
            set { _componentid = value; }
        }

        [Id(Name = "StartDate")]
        public DateTime Startdate
        {
            get { return _startdate; }
            set { _startdate = value; }
        }

        [Column(Name = "EndDate", Required = false)]
        public DateTime? Enddate
        {
            get { return _enddate; }
            set { _enddate = value; }
        }

        [Id(Name = "UnitMeasureCode")]
        public string Unitmeasurecode
        {
            get { return _unitmeasurecode; }
            set { _unitmeasurecode = value; }
        }

        [Column(Name = "BOMLevel", Required = true)]
        public Int16 Bomlevel
        {
            get { return _bomlevel; }
            set { _bomlevel = value; }
        }

        [Column(Name = "PerAssemblyQty", Required = true)]
        public decimal Perassemblyqty
        {
            get { return _perassemblyqty; }
            set { _perassemblyqty = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.Culture")]
    public class Culture
    {
        private string _cultureid;
        private string _name;
        private DateTime _modifieddate;

        [Id(Name = "CultureID")]
        public string Cultureid
        {
            get { return _cultureid; }
            set { _cultureid = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.Document")]
    public class Document
    {
        private Int32 _documentid;
        private string _title;
        private string _filename;
        private string _fileextension;
        private string _revision;
        private Int32 _changenumber;
        private Int16 _status;
        private string _documentsummary;
        private DateTime _modifieddate;

        [Id(Name = "DocumentID")]
        public Int32 Documentid
        {
            get { return _documentid; }
            set { _documentid = value; }
        }

        [Column(Name = "Title", Required = true)]
        public string Title
        {
            get { return _title; }
            set { _title = value; }
        }

        [Id(Name = "FileName")]
        public string Filename
        {
            get { return _filename; }
            set { _filename = value; }
        }

        [Column(Name = "FileExtension", Required = true)]
        public string Fileextension
        {
            get { return _fileextension; }
            set { _fileextension = value; }
        }

        [Id(Name = "Revision")]
        public string Revision
        {
            get { return _revision; }
            set { _revision = value; }
        }

        [Column(Name = "ChangeNumber", Required = true)]
        public Int32 Changenumber
        {
            get { return _changenumber; }
            set { _changenumber = value; }
        }

        [Column(Name = "Status", Required = true)]
        public Int16 Status
        {
            get { return _status; }
            set { _status = value; }
        }

        [Column(Name = "DocumentSummary", Required = false)]
        public string Documentsummary
        {
            get { return _documentsummary; }
            set { _documentsummary = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.Illustration")]
    public class Illustration
    {
        private Int32 _illustrationid;
        private string _diagram;
        private DateTime _modifieddate;

        [Id(Name = "IllustrationID")]
        public Int32 Illustrationid
        {
            get { return _illustrationid; }
            set { _illustrationid = value; }
        }

        [Column(Name = "Diagram", Required = false)]
        public string Diagram
        {
            get { return _diagram; }
            set { _diagram = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.Location")]
    public class Location
    {
        private Int16 _locationid;
        private string _name;
        private decimal _costrate;
        private decimal _availability;
        private DateTime _modifieddate;

        [Id(Name = "LocationID")]
        public Int16 Locationid
        {
            get { return _locationid; }
            set { _locationid = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Column(Name = "CostRate", Required = true)]
        public decimal Costrate
        {
            get { return _costrate; }
            set { _costrate = value; }
        }

        [Column(Name = "Availability", Required = true)]
        public decimal Availability
        {
            get { return _availability; }
            set { _availability = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.Product")]
    public class Product
    {
        private Int32 _productid;
        private string _name;
        private string _productnumber;
        private bool _makeflag;
        private bool _finishedgoodsflag;
        private string _color;
        private Int16 _safetystocklevel;
        private Int16 _reorderpoint;
        private decimal _standardcost;
        private decimal _listprice;
        private string _size;
        private string _sizeunitmeasurecode;
        private string _weightunitmeasurecode;
        private decimal _weight;
        private Int32 _daystomanufacture;
        private string _productline;
        private string _class;
        private string _style;
        private Int32? _productsubcategoryid;
        private Int32? _productmodelid;
        private DateTime _sellstartdate;
        private DateTime? _sellenddate;
        private DateTime? _discontinueddate;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Id(Name = "ProductNumber")]
        public string Productnumber
        {
            get { return _productnumber; }
            set { _productnumber = value; }
        }

        [Column(Name = "MakeFlag", Required = true)]
        public bool Makeflag
        {
            get { return _makeflag; }
            set { _makeflag = value; }
        }

        [Column(Name = "FinishedGoodsFlag", Required = true)]
        public bool Finishedgoodsflag
        {
            get { return _finishedgoodsflag; }
            set { _finishedgoodsflag = value; }
        }

        [Column(Name = "Color", Required = false)]
        public string Color
        {
            get { return _color; }
            set { _color = value; }
        }

        [Column(Name = "SafetyStockLevel", Required = true)]
        public Int16 Safetystocklevel
        {
            get { return _safetystocklevel; }
            set { _safetystocklevel = value; }
        }

        [Column(Name = "ReorderPoint", Required = true)]
        public Int16 Reorderpoint
        {
            get { return _reorderpoint; }
            set { _reorderpoint = value; }
        }

        [Column(Name = "StandardCost", Required = true)]
        public decimal Standardcost
        {
            get { return _standardcost; }
            set { _standardcost = value; }
        }

        [Column(Name = "ListPrice", Required = true)]
        public decimal Listprice
        {
            get { return _listprice; }
            set { _listprice = value; }
        }

        [Column(Name = "Size", Required = false)]
        public string Size
        {
            get { return _size; }
            set { _size = value; }
        }

        [Column(Name = "SizeUnitMeasureCode", Required = false)]
        public string Sizeunitmeasurecode
        {
            get { return _sizeunitmeasurecode; }
            set { _sizeunitmeasurecode = value; }
        }

        [Column(Name = "WeightUnitMeasureCode", Required = false)]
        public string Weightunitmeasurecode
        {
            get { return _weightunitmeasurecode; }
            set { _weightunitmeasurecode = value; }
        }

        [Column(Name = "Weight", Required = false)]
        public decimal Weight
        {
            get { return _weight; }
            set { _weight = value; }
        }

        [Column(Name = "DaysToManufacture", Required = true)]
        public Int32 Daystomanufacture
        {
            get { return _daystomanufacture; }
            set { _daystomanufacture = value; }
        }

        [Column(Name = "ProductLine", Required = false)]
        public string Productline
        {
            get { return _productline; }
            set { _productline = value; }
        }

        [Column(Name = "Class", Required = false)]
        public string Class
        {
            get { return _class; }
            set { _class = value; }
        }

        [Column(Name = "Style", Required = false)]
        public string Style
        {
            get { return _style; }
            set { _style = value; }
        }

        [Column(Name = "ProductSubcategoryID", Required = false)]
        public Int32? Productsubcategoryid
        {
            get { return _productsubcategoryid; }
            set { _productsubcategoryid = value; }
        }

        [Column(Name = "ProductModelID", Required = false)]
        public Int32? Productmodelid
        {
            get { return _productmodelid; }
            set { _productmodelid = value; }
        }

        [Column(Name = "SellStartDate", Required = true)]
        public DateTime Sellstartdate
        {
            get { return _sellstartdate; }
            set { _sellstartdate = value; }
        }

        [Column(Name = "SellEndDate", Required = false)]
        public DateTime? Sellenddate
        {
            get { return _sellenddate; }
            set { _sellenddate = value; }
        }

        [Column(Name = "DiscontinuedDate", Required = false)]
        public DateTime? Discontinueddate
        {
            get { return _discontinueddate; }
            set { _discontinueddate = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.ProductCategory")]
    public class Productcategory
    {
        private Int32 _productcategoryid;
        private string _name;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "ProductCategoryID")]
        public Int32 Productcategoryid
        {
            get { return _productcategoryid; }
            set { _productcategoryid = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.ProductCostHistory")]
    public class Productcosthistory
    {
        private Int32 _productid;
        private DateTime _startdate;
        private DateTime? _enddate;
        private decimal _standardcost;
        private DateTime _modifieddate;

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Id(Name = "StartDate")]
        public DateTime Startdate
        {
            get { return _startdate; }
            set { _startdate = value; }
        }

        [Column(Name = "EndDate", Required = false)]
        public DateTime? Enddate
        {
            get { return _enddate; }
            set { _enddate = value; }
        }

        [Column(Name = "StandardCost", Required = true)]
        public decimal Standardcost
        {
            get { return _standardcost; }
            set { _standardcost = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.ProductDescription")]
    public class Productdescription
    {
        private Int32 _productdescriptionid;
        private string _description;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "ProductDescriptionID")]
        public Int32 Productdescriptionid
        {
            get { return _productdescriptionid; }
            set { _productdescriptionid = value; }
        }

        [Column(Name = "Description", Required = true)]
        public string Description
        {
            get { return _description; }
            set { _description = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.ProductDocument")]
    public class Productdocument
    {
        private Int32 _productid;
        private Int32 _documentid;
        private DateTime _modifieddate;

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Id(Name = "DocumentID")]
        public Int32 Documentid
        {
            get { return _documentid; }
            set { _documentid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.ProductInventory")]
    public class Productinventory
    {
        private Int32 _productid;
        private Int16 _locationid;
        private string _shelf;
        private Int16 _bin;
        private Int16 _quantity;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Id(Name = "LocationID")]
        public Int16 Locationid
        {
            get { return _locationid; }
            set { _locationid = value; }
        }

        [Column(Name = "Shelf", Required = true)]
        public string Shelf
        {
            get { return _shelf; }
            set { _shelf = value; }
        }

        [Column(Name = "Bin", Required = true)]
        public Int16 Bin
        {
            get { return _bin; }
            set { _bin = value; }
        }

        [Column(Name = "Quantity", Required = true)]
        public Int16 Quantity
        {
            get { return _quantity; }
            set { _quantity = value; }
        }

        [Column(Name = "rowguid", Required = true)]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.ProductListPriceHistory")]
    public class Productlistpricehistory
    {
        private Int32 _productid;
        private DateTime _startdate;
        private DateTime? _enddate;
        private decimal _listprice;
        private DateTime _modifieddate;

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Id(Name = "StartDate")]
        public DateTime Startdate
        {
            get { return _startdate; }
            set { _startdate = value; }
        }

        [Column(Name = "EndDate", Required = false)]
        public DateTime? Enddate
        {
            get { return _enddate; }
            set { _enddate = value; }
        }

        [Column(Name = "ListPrice", Required = true)]
        public decimal Listprice
        {
            get { return _listprice; }
            set { _listprice = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.ProductModel")]
    public class Productmodel
    {
        private Int32 _productmodelid;
        private string _name;
        private string _catalogdescription;
        private string _instructions;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "ProductModelID")]
        public Int32 Productmodelid
        {
            get { return _productmodelid; }
            set { _productmodelid = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Id(Name = "CatalogDescription")]
        public string Catalogdescription
        {
            get { return _catalogdescription; }
            set { _catalogdescription = value; }
        }

        [Id(Name = "Instructions")]
        public string Instructions
        {
            get { return _instructions; }
            set { _instructions = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.ProductModelIllustration")]
    public class Productmodelillustration
    {
        private Int32 _productmodelid;
        private Int32 _illustrationid;
        private DateTime _modifieddate;

        [Id(Name = "ProductModelID")]
        public Int32 Productmodelid
        {
            get { return _productmodelid; }
            set { _productmodelid = value; }
        }

        [Id(Name = "IllustrationID")]
        public Int32 Illustrationid
        {
            get { return _illustrationid; }
            set { _illustrationid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.ProductModelProductDescriptionCulture")]
    public class Productmodelproductdescriptionculture
    {
        private Int32 _productmodelid;
        private Int32 _productdescriptionid;
        private string _cultureid;
        private DateTime _modifieddate;

        [Id(Name = "ProductModelID")]
        public Int32 Productmodelid
        {
            get { return _productmodelid; }
            set { _productmodelid = value; }
        }

        [Id(Name = "ProductDescriptionID")]
        public Int32 Productdescriptionid
        {
            get { return _productdescriptionid; }
            set { _productdescriptionid = value; }
        }

        [Id(Name = "CultureID")]
        public string Cultureid
        {
            get { return _cultureid; }
            set { _cultureid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.ProductPhoto")]
    public class Productphoto
    {
        private Int32 _productphotoid;
        private object _thumbnailphoto;
        private string _thumbnailphotofilename;
        private object _largephoto;
        private string _largephotofilename;
        private DateTime _modifieddate;

        [Id(Name = "ProductPhotoID")]
        public Int32 Productphotoid
        {
            get { return _productphotoid; }
            set { _productphotoid = value; }
        }

        [Column(Name = "ThumbNailPhoto", Required = false)]
        public object Thumbnailphoto
        {
            get { return _thumbnailphoto; }
            set { _thumbnailphoto = value; }
        }

        [Column(Name = "ThumbnailPhotoFileName", Required = false)]
        public string Thumbnailphotofilename
        {
            get { return _thumbnailphotofilename; }
            set { _thumbnailphotofilename = value; }
        }

        [Column(Name = "LargePhoto", Required = false)]
        public object Largephoto
        {
            get { return _largephoto; }
            set { _largephoto = value; }
        }

        [Column(Name = "LargePhotoFileName", Required = false)]
        public string Largephotofilename
        {
            get { return _largephotofilename; }
            set { _largephotofilename = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.ProductProductPhoto")]
    public class Productproductphoto
    {
        private Int32 _productid;
        private Int32 _productphotoid;
        private bool _primary;
        private DateTime _modifieddate;

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Id(Name = "ProductPhotoID")]
        public Int32 Productphotoid
        {
            get { return _productphotoid; }
            set { _productphotoid = value; }
        }

        [Column(Name = "Primary", Required = true)]
        public bool Primary
        {
            get { return _primary; }
            set { _primary = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.ProductReview")]
    public class Productreview
    {
        private Int32 _productreviewid;
        private Int32 _productid;
        private string _reviewername;
        private DateTime _reviewdate;
        private string _emailaddress;
        private Int32 _rating;
        private string _comments;
        private DateTime _modifieddate;

        [Id(Name = "ProductReviewID")]
        public Int32 Productreviewid
        {
            get { return _productreviewid; }
            set { _productreviewid = value; }
        }

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Id(Name = "ReviewerName")]
        public string Reviewername
        {
            get { return _reviewername; }
            set { _reviewername = value; }
        }

        [Column(Name = "ReviewDate", Required = true)]
        public DateTime Reviewdate
        {
            get { return _reviewdate; }
            set { _reviewdate = value; }
        }

        [Column(Name = "EmailAddress", Required = true)]
        public string Emailaddress
        {
            get { return _emailaddress; }
            set { _emailaddress = value; }
        }

        [Column(Name = "Rating", Required = true)]
        public Int32 Rating
        {
            get { return _rating; }
            set { _rating = value; }
        }

        [Id(Name = "Comments")]
        public string Comments
        {
            get { return _comments; }
            set { _comments = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.ProductSubcategory")]
    public class Productsubcategory
    {
        private Int32 _productsubcategoryid;
        private Int32 _productcategoryid;
        private string _name;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "ProductSubcategoryID")]
        public Int32 Productsubcategoryid
        {
            get { return _productsubcategoryid; }
            set { _productsubcategoryid = value; }
        }

        [Column(Name = "ProductCategoryID", Required = true)]
        public Int32 Productcategoryid
        {
            get { return _productcategoryid; }
            set { _productcategoryid = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.ScrapReason")]
    public class Scrapreason
    {
        private Int16 _scrapreasonid;
        private string _name;
        private DateTime _modifieddate;

        [Id(Name = "ScrapReasonID")]
        public Int16 Scrapreasonid
        {
            get { return _scrapreasonid; }
            set { _scrapreasonid = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.TransactionHistory")]
    public class Transactionhistory
    {
        private Int32 _transactionid;
        private Int32 _productid;
        private Int32 _referenceorderid;
        private Int32 _referenceorderlineid;
        private DateTime _transactiondate;
        private string _transactiontype;
        private Int32 _quantity;
        private decimal _actualcost;
        private DateTime _modifieddate;

        [Id(Name = "TransactionID")]
        public Int32 Transactionid
        {
            get { return _transactionid; }
            set { _transactionid = value; }
        }

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Id(Name = "ReferenceOrderID")]
        public Int32 Referenceorderid
        {
            get { return _referenceorderid; }
            set { _referenceorderid = value; }
        }

        [Id(Name = "ReferenceOrderLineID")]
        public Int32 Referenceorderlineid
        {
            get { return _referenceorderlineid; }
            set { _referenceorderlineid = value; }
        }

        [Column(Name = "TransactionDate", Required = true)]
        public DateTime Transactiondate
        {
            get { return _transactiondate; }
            set { _transactiondate = value; }
        }

        [Column(Name = "TransactionType", Required = true)]
        public string Transactiontype
        {
            get { return _transactiontype; }
            set { _transactiontype = value; }
        }

        [Column(Name = "Quantity", Required = true)]
        public Int32 Quantity
        {
            get { return _quantity; }
            set { _quantity = value; }
        }

        [Column(Name = "ActualCost", Required = true)]
        public decimal Actualcost
        {
            get { return _actualcost; }
            set { _actualcost = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.TransactionHistoryArchive")]
    public class Transactionhistoryarchive
    {
        private Int32 _transactionid;
        private Int32 _productid;
        private Int32 _referenceorderid;
        private Int32 _referenceorderlineid;
        private DateTime _transactiondate;
        private string _transactiontype;
        private Int32 _quantity;
        private decimal _actualcost;
        private DateTime _modifieddate;

        [Id(Name = "TransactionID")]
        public Int32 Transactionid
        {
            get { return _transactionid; }
            set { _transactionid = value; }
        }

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Id(Name = "ReferenceOrderID")]
        public Int32 Referenceorderid
        {
            get { return _referenceorderid; }
            set { _referenceorderid = value; }
        }

        [Id(Name = "ReferenceOrderLineID")]
        public Int32 Referenceorderlineid
        {
            get { return _referenceorderlineid; }
            set { _referenceorderlineid = value; }
        }

        [Column(Name = "TransactionDate", Required = true)]
        public DateTime Transactiondate
        {
            get { return _transactiondate; }
            set { _transactiondate = value; }
        }

        [Column(Name = "TransactionType", Required = true)]
        public string Transactiontype
        {
            get { return _transactiontype; }
            set { _transactiontype = value; }
        }

        [Column(Name = "Quantity", Required = true)]
        public Int32 Quantity
        {
            get { return _quantity; }
            set { _quantity = value; }
        }

        [Column(Name = "ActualCost", Required = true)]
        public decimal Actualcost
        {
            get { return _actualcost; }
            set { _actualcost = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.UnitMeasure")]
    public class Unitmeasure
    {
        private string _unitmeasurecode;
        private string _name;
        private DateTime _modifieddate;

        [Id(Name = "UnitMeasureCode")]
        public string Unitmeasurecode
        {
            get { return _unitmeasurecode; }
            set { _unitmeasurecode = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.WorkOrder")]
    public class Workorder
    {
        private Int32 _workorderid;
        private Int32 _productid;
        private Int32 _orderqty;
        private Int32 _stockedqty;
        private Int16 _scrappedqty;
        private DateTime _startdate;
        private DateTime? _enddate;
        private DateTime _duedate;
        private Int16? _scrapreasonid;
        private DateTime _modifieddate;

        [Id(Name = "WorkOrderID")]
        public Int32 Workorderid
        {
            get { return _workorderid; }
            set { _workorderid = value; }
        }

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Column(Name = "OrderQty", Required = true)]
        public Int32 Orderqty
        {
            get { return _orderqty; }
            set { _orderqty = value; }
        }

        [Column(Name = "StockedQty", Required = true)]
        public Int32 Stockedqty
        {
            get { return _stockedqty; }
            set { _stockedqty = value; }
        }

        [Column(Name = "ScrappedQty", Required = true)]
        public Int16 Scrappedqty
        {
            get { return _scrappedqty; }
            set { _scrappedqty = value; }
        }

        [Column(Name = "StartDate", Required = true)]
        public DateTime Startdate
        {
            get { return _startdate; }
            set { _startdate = value; }
        }

        [Column(Name = "EndDate", Required = false)]
        public DateTime? Enddate
        {
            get { return _enddate; }
            set { _enddate = value; }
        }

        [Column(Name = "DueDate", Required = true)]
        public DateTime Duedate
        {
            get { return _duedate; }
            set { _duedate = value; }
        }

        [Id(Name = "ScrapReasonID")]
        public Int16? Scrapreasonid
        {
            get { return _scrapreasonid; }
            set { _scrapreasonid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Production.WorkOrderRouting")]
    public class Workorderrouting
    {
        private Int32 _workorderid;
        private Int32 _productid;
        private Int16 _operationsequence;
        private Int16 _locationid;
        private DateTime _scheduledstartdate;
        private DateTime _scheduledenddate;
        private DateTime? _actualstartdate;
        private DateTime? _actualenddate;
        private decimal _actualresourcehrs;
        private decimal _plannedcost;
        private decimal _actualcost;
        private DateTime _modifieddate;

        [Id(Name = "WorkOrderID")]
        public Int32 Workorderid
        {
            get { return _workorderid; }
            set { _workorderid = value; }
        }

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Id(Name = "OperationSequence")]
        public Int16 Operationsequence
        {
            get { return _operationsequence; }
            set { _operationsequence = value; }
        }

        [Column(Name = "LocationID", Required = true)]
        public Int16 Locationid
        {
            get { return _locationid; }
            set { _locationid = value; }
        }

        [Column(Name = "ScheduledStartDate", Required = true)]
        public DateTime Scheduledstartdate
        {
            get { return _scheduledstartdate; }
            set { _scheduledstartdate = value; }
        }

        [Column(Name = "ScheduledEndDate", Required = true)]
        public DateTime Scheduledenddate
        {
            get { return _scheduledenddate; }
            set { _scheduledenddate = value; }
        }

        [Column(Name = "ActualStartDate", Required = false)]
        public DateTime? Actualstartdate
        {
            get { return _actualstartdate; }
            set { _actualstartdate = value; }
        }

        [Column(Name = "ActualEndDate", Required = false)]
        public DateTime? Actualenddate
        {
            get { return _actualenddate; }
            set { _actualenddate = value; }
        }

        [Column(Name = "ActualResourceHrs", Required = false)]
        public decimal Actualresourcehrs
        {
            get { return _actualresourcehrs; }
            set { _actualresourcehrs = value; }
        }

        [Column(Name = "PlannedCost", Required = true)]
        public decimal Plannedcost
        {
            get { return _plannedcost; }
            set { _plannedcost = value; }
        }

        [Column(Name = "ActualCost", Required = false)]
        public decimal Actualcost
        {
            get { return _actualcost; }
            set { _actualcost = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Purchasing.ProductVendor")]
    public class Productvendor
    {
        private Int32 _productid;
        private Int32 _vendorid;
        private Int32 _averageleadtime;
        private decimal _standardprice;
        private decimal _lastreceiptcost;
        private DateTime? _lastreceiptdate;
        private Int32 _minorderqty;
        private Int32 _maxorderqty;
        private Int32? _onorderqty;
        private string _unitmeasurecode;
        private DateTime _modifieddate;

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Id(Name = "VendorID")]
        public Int32 Vendorid
        {
            get { return _vendorid; }
            set { _vendorid = value; }
        }

        [Column(Name = "AverageLeadTime", Required = true)]
        public Int32 Averageleadtime
        {
            get { return _averageleadtime; }
            set { _averageleadtime = value; }
        }

        [Column(Name = "StandardPrice", Required = true)]
        public decimal Standardprice
        {
            get { return _standardprice; }
            set { _standardprice = value; }
        }

        [Column(Name = "LastReceiptCost", Required = false)]
        public decimal Lastreceiptcost
        {
            get { return _lastreceiptcost; }
            set { _lastreceiptcost = value; }
        }

        [Column(Name = "LastReceiptDate", Required = false)]
        public DateTime? Lastreceiptdate
        {
            get { return _lastreceiptdate; }
            set { _lastreceiptdate = value; }
        }

        [Column(Name = "MinOrderQty", Required = true)]
        public Int32 Minorderqty
        {
            get { return _minorderqty; }
            set { _minorderqty = value; }
        }

        [Column(Name = "MaxOrderQty", Required = true)]
        public Int32 Maxorderqty
        {
            get { return _maxorderqty; }
            set { _maxorderqty = value; }
        }

        [Column(Name = "OnOrderQty", Required = false)]
        public Int32? Onorderqty
        {
            get { return _onorderqty; }
            set { _onorderqty = value; }
        }

        [Id(Name = "UnitMeasureCode")]
        public string Unitmeasurecode
        {
            get { return _unitmeasurecode; }
            set { _unitmeasurecode = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Purchasing.PurchaseOrderDetail")]
    public class Purchaseorderdetail
    {
        private Int32 _purchaseorderid;
        private Int32 _purchaseorderdetailid;
        private DateTime _duedate;
        private Int16 _orderqty;
        private Int32 _productid;
        private decimal _unitprice;
        private decimal _linetotal;
        private decimal _receivedqty;
        private decimal _rejectedqty;
        private decimal _stockedqty;
        private DateTime _modifieddate;

        [Id(Name = "PurchaseOrderID")]
        public Int32 Purchaseorderid
        {
            get { return _purchaseorderid; }
            set { _purchaseorderid = value; }
        }

        [Id(Name = "PurchaseOrderDetailID")]
        public Int32 Purchaseorderdetailid
        {
            get { return _purchaseorderdetailid; }
            set { _purchaseorderdetailid = value; }
        }

        [Column(Name = "DueDate", Required = true)]
        public DateTime Duedate
        {
            get { return _duedate; }
            set { _duedate = value; }
        }

        [Column(Name = "OrderQty", Required = true)]
        public Int16 Orderqty
        {
            get { return _orderqty; }
            set { _orderqty = value; }
        }

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Column(Name = "UnitPrice", Required = true)]
        public decimal Unitprice
        {
            get { return _unitprice; }
            set { _unitprice = value; }
        }

        [Column(Name = "LineTotal", Required = true)]
        public decimal Linetotal
        {
            get { return _linetotal; }
            set { _linetotal = value; }
        }

        [Column(Name = "ReceivedQty", Required = true)]
        public decimal Receivedqty
        {
            get { return _receivedqty; }
            set { _receivedqty = value; }
        }

        [Column(Name = "RejectedQty", Required = true)]
        public decimal Rejectedqty
        {
            get { return _rejectedqty; }
            set { _rejectedqty = value; }
        }

        [Column(Name = "StockedQty", Required = true)]
        public decimal Stockedqty
        {
            get { return _stockedqty; }
            set { _stockedqty = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Purchasing.PurchaseOrderHeader")]
    public class Purchaseorderheader
    {
        private Int32 _purchaseorderid;
        private Int16 _revisionnumber;
        private Int16 _status;
        private Int32 _employeeid;
        private Int32 _vendorid;
        private Int32 _shipmethodid;
        private DateTime _orderdate;
        private DateTime? _shipdate;
        private decimal _subtotal;
        private decimal _taxamt;
        private decimal _freight;
        private decimal _totaldue;
        private DateTime _modifieddate;

        [Id(Name = "PurchaseOrderID")]
        public Int32 Purchaseorderid
        {
            get { return _purchaseorderid; }
            set { _purchaseorderid = value; }
        }

        [Column(Name = "RevisionNumber", Required = true)]
        public Int16 Revisionnumber
        {
            get { return _revisionnumber; }
            set { _revisionnumber = value; }
        }

        [Column(Name = "Status", Required = true)]
        public Int16 Status
        {
            get { return _status; }
            set { _status = value; }
        }

        [Id(Name = "EmployeeID")]
        public Int32 Employeeid
        {
            get { return _employeeid; }
            set { _employeeid = value; }
        }

        [Id(Name = "VendorID")]
        public Int32 Vendorid
        {
            get { return _vendorid; }
            set { _vendorid = value; }
        }

        [Column(Name = "ShipMethodID", Required = true)]
        public Int32 Shipmethodid
        {
            get { return _shipmethodid; }
            set { _shipmethodid = value; }
        }

        [Column(Name = "OrderDate", Required = true)]
        public DateTime Orderdate
        {
            get { return _orderdate; }
            set { _orderdate = value; }
        }

        [Column(Name = "ShipDate", Required = false)]
        public DateTime? Shipdate
        {
            get { return _shipdate; }
            set { _shipdate = value; }
        }

        [Column(Name = "SubTotal", Required = true)]
        public decimal Subtotal
        {
            get { return _subtotal; }
            set { _subtotal = value; }
        }

        [Column(Name = "TaxAmt", Required = true)]
        public decimal Taxamt
        {
            get { return _taxamt; }
            set { _taxamt = value; }
        }

        [Column(Name = "Freight", Required = true)]
        public decimal Freight
        {
            get { return _freight; }
            set { _freight = value; }
        }

        [Column(Name = "TotalDue", Required = true)]
        public decimal Totaldue
        {
            get { return _totaldue; }
            set { _totaldue = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Purchasing.ShipMethod")]
    public class Shipmethod
    {
        private Int32 _shipmethodid;
        private string _name;
        private decimal _shipbase;
        private decimal _shiprate;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "ShipMethodID")]
        public Int32 Shipmethodid
        {
            get { return _shipmethodid; }
            set { _shipmethodid = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Column(Name = "ShipBase", Required = true)]
        public decimal Shipbase
        {
            get { return _shipbase; }
            set { _shipbase = value; }
        }

        [Column(Name = "ShipRate", Required = true)]
        public decimal Shiprate
        {
            get { return _shiprate; }
            set { _shiprate = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Purchasing.Vendor")]
    public class Vendor
    {
        private Int32 _vendorid;
        private string _accountnumber;
        private string _name;
        private Int16 _creditrating;
        private bool _preferredvendorstatus;
        private bool _activeflag;
        private string _purchasingwebserviceurl;
        private DateTime _modifieddate;

        [Id(Name = "VendorID")]
        public Int32 Vendorid
        {
            get { return _vendorid; }
            set { _vendorid = value; }
        }

        [Id(Name = "AccountNumber")]
        public string Accountnumber
        {
            get { return _accountnumber; }
            set { _accountnumber = value; }
        }

        [Column(Name = "Name", Required = true)]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Column(Name = "CreditRating", Required = true)]
        public Int16 Creditrating
        {
            get { return _creditrating; }
            set { _creditrating = value; }
        }

        [Column(Name = "PreferredVendorStatus", Required = true)]
        public bool Preferredvendorstatus
        {
            get { return _preferredvendorstatus; }
            set { _preferredvendorstatus = value; }
        }

        [Column(Name = "ActiveFlag", Required = true)]
        public bool Activeflag
        {
            get { return _activeflag; }
            set { _activeflag = value; }
        }

        [Column(Name = "PurchasingWebServiceURL", Required = false)]
        public string Purchasingwebserviceurl
        {
            get { return _purchasingwebserviceurl; }
            set { _purchasingwebserviceurl = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Purchasing.VendorAddress")]
    public class Vendoraddress
    {
        private Int32 _vendorid;
        private Int32 _addressid;
        private Int32 _addresstypeid;
        private DateTime _modifieddate;

        [Id(Name = "VendorID")]
        public Int32 Vendorid
        {
            get { return _vendorid; }
            set { _vendorid = value; }
        }

        [Id(Name = "AddressID")]
        public Int32 Addressid
        {
            get { return _addressid; }
            set { _addressid = value; }
        }

        [Column(Name = "AddressTypeID", Required = true)]
        public Int32 Addresstypeid
        {
            get { return _addresstypeid; }
            set { _addresstypeid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Purchasing.VendorContact")]
    public class Vendorcontact
    {
        private Int32 _vendorid;
        private Int32 _contactid;
        private Int32 _contacttypeid;
        private DateTime _modifieddate;

        [Id(Name = "VendorID")]
        public Int32 Vendorid
        {
            get { return _vendorid; }
            set { _vendorid = value; }
        }

        [Id(Name = "ContactID")]
        public Int32 Contactid
        {
            get { return _contactid; }
            set { _contactid = value; }
        }

        [Id(Name = "ContactTypeID")]
        public Int32 Contacttypeid
        {
            get { return _contacttypeid; }
            set { _contacttypeid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.ContactCreditCard")]
    public class Contactcreditcard
    {
        private Int32 _contactid;
        private Int32 _creditcardid;
        private DateTime _modifieddate;

        [Id(Name = "ContactID")]
        public Int32 Contactid
        {
            get { return _contactid; }
            set { _contactid = value; }
        }

        [Id(Name = "CreditCardID")]
        public Int32 Creditcardid
        {
            get { return _creditcardid; }
            set { _creditcardid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.CountryRegionCurrency")]
    public class Countryregioncurrency
    {
        private string _countryregioncode;
        private string _currencycode;
        private DateTime _modifieddate;

        [Id(Name = "CountryRegionCode")]
        public string Countryregioncode
        {
            get { return _countryregioncode; }
            set { _countryregioncode = value; }
        }

        [Id(Name = "CurrencyCode")]
        public string Currencycode
        {
            get { return _currencycode; }
            set { _currencycode = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.CreditCard")]
    public class Creditcard
    {
        private Int32 _creditcardid;
        private string _cardtype;
        private string _cardnumber;
        private Int16 _expmonth;
        private Int16 _expyear;
        private DateTime _modifieddate;

        [Id(Name = "CreditCardID")]
        public Int32 Creditcardid
        {
            get { return _creditcardid; }
            set { _creditcardid = value; }
        }

        [Column(Name = "CardType", Required = true)]
        public string Cardtype
        {
            get { return _cardtype; }
            set { _cardtype = value; }
        }

        [Id(Name = "CardNumber")]
        public string Cardnumber
        {
            get { return _cardnumber; }
            set { _cardnumber = value; }
        }

        [Column(Name = "ExpMonth", Required = true)]
        public Int16 Expmonth
        {
            get { return _expmonth; }
            set { _expmonth = value; }
        }

        [Column(Name = "ExpYear", Required = true)]
        public Int16 Expyear
        {
            get { return _expyear; }
            set { _expyear = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.Currency")]
    public class Currency
    {
        private string _currencycode;
        private string _name;
        private DateTime _modifieddate;

        [Id(Name = "CurrencyCode")]
        public string Currencycode
        {
            get { return _currencycode; }
            set { _currencycode = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.CurrencyRate")]
    public class Currencyrate
    {
        private Int32 _currencyrateid;
        private DateTime _currencyratedate;
        private string _fromcurrencycode;
        private string _tocurrencycode;
        private decimal _averagerate;
        private decimal _endofdayrate;
        private DateTime _modifieddate;

        [Id(Name = "CurrencyRateID")]
        public Int32 Currencyrateid
        {
            get { return _currencyrateid; }
            set { _currencyrateid = value; }
        }

        [Id(Name = "CurrencyRateDate")]
        public DateTime Currencyratedate
        {
            get { return _currencyratedate; }
            set { _currencyratedate = value; }
        }

        [Id(Name = "FromCurrencyCode")]
        public string Fromcurrencycode
        {
            get { return _fromcurrencycode; }
            set { _fromcurrencycode = value; }
        }

        [Id(Name = "ToCurrencyCode")]
        public string Tocurrencycode
        {
            get { return _tocurrencycode; }
            set { _tocurrencycode = value; }
        }

        [Column(Name = "AverageRate", Required = true)]
        public decimal Averagerate
        {
            get { return _averagerate; }
            set { _averagerate = value; }
        }

        [Column(Name = "EndOfDayRate", Required = true)]
        public decimal Endofdayrate
        {
            get { return _endofdayrate; }
            set { _endofdayrate = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.Customer")]
    public class Customer
    {
        private Int32 _customerid;
        private Int32? _territoryid;
        private string _accountnumber;
        private string _customertype;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "CustomerID")]
        public Int32 Customerid
        {
            get { return _customerid; }
            set { _customerid = value; }
        }

        [Id(Name = "TerritoryID")]
        public Int32? Territoryid
        {
            get { return _territoryid; }
            set { _territoryid = value; }
        }

        [Id(Name = "AccountNumber")]
        public string Accountnumber
        {
            get { return _accountnumber; }
            set { _accountnumber = value; }
        }

        [Column(Name = "CustomerType", Required = true)]
        public string Customertype
        {
            get { return _customertype; }
            set { _customertype = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.CustomerAddress")]
    public class Customeraddress
    {
        private Int32 _customerid;
        private Int32 _addressid;
        private Int32 _addresstypeid;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "CustomerID")]
        public Int32 Customerid
        {
            get { return _customerid; }
            set { _customerid = value; }
        }

        [Id(Name = "AddressID")]
        public Int32 Addressid
        {
            get { return _addressid; }
            set { _addressid = value; }
        }

        [Column(Name = "AddressTypeID", Required = true)]
        public Int32 Addresstypeid
        {
            get { return _addresstypeid; }
            set { _addresstypeid = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.Individual")]
    public class Individual
    {
        private Int32 _customerid;
        private Int32 _contactid;
        private string _demographics;
        private DateTime _modifieddate;

        [Id(Name = "CustomerID")]
        public Int32 Customerid
        {
            get { return _customerid; }
            set { _customerid = value; }
        }

        [Column(Name = "ContactID", Required = true)]
        public Int32 Contactid
        {
            get { return _contactid; }
            set { _contactid = value; }
        }

        [Id(Name = "Demographics")]
        public string Demographics
        {
            get { return _demographics; }
            set { _demographics = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.SalesOrderDetail")]
    public class Salesorderdetail
    {
        private Int32 _salesorderid;
        private Int32 _salesorderdetailid;
        private string _carriertrackingnumber;
        private Int16 _orderqty;
        private Int32 _productid;
        private Int32 _specialofferid;
        private decimal _unitprice;
        private decimal _unitpricediscount;
        private decimal _linetotal;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "SalesOrderID")]
        public Int32 Salesorderid
        {
            get { return _salesorderid; }
            set { _salesorderid = value; }
        }

        [Id(Name = "SalesOrderDetailID")]
        public Int32 Salesorderdetailid
        {
            get { return _salesorderdetailid; }
            set { _salesorderdetailid = value; }
        }

        [Column(Name = "CarrierTrackingNumber", Required = false)]
        public string Carriertrackingnumber
        {
            get { return _carriertrackingnumber; }
            set { _carriertrackingnumber = value; }
        }

        [Column(Name = "OrderQty", Required = true)]
        public Int16 Orderqty
        {
            get { return _orderqty; }
            set { _orderqty = value; }
        }

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Column(Name = "SpecialOfferID", Required = true)]
        public Int32 Specialofferid
        {
            get { return _specialofferid; }
            set { _specialofferid = value; }
        }

        [Column(Name = "UnitPrice", Required = true)]
        public decimal Unitprice
        {
            get { return _unitprice; }
            set { _unitprice = value; }
        }

        [Column(Name = "UnitPriceDiscount", Required = true)]
        public decimal Unitpricediscount
        {
            get { return _unitpricediscount; }
            set { _unitpricediscount = value; }
        }

        [Column(Name = "LineTotal", Required = true)]
        public decimal Linetotal
        {
            get { return _linetotal; }
            set { _linetotal = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.SalesOrderHeader")]
    public class Salesorderheader
    {
        private Int32 _salesorderid;
        private Int16 _revisionnumber;
        private DateTime _orderdate;
        private DateTime _duedate;
        private DateTime? _shipdate;
        private Int16 _status;
        private bool _onlineorderflag;
        private string _salesordernumber;
        private string _purchaseordernumber;
        private string _accountnumber;
        private Int32 _customerid;
        private Int32 _contactid;
        private Int32? _salespersonid;
        private Int32? _territoryid;
        private Int32 _billtoaddressid;
        private Int32 _shiptoaddressid;
        private Int32 _shipmethodid;
        private Int32? _creditcardid;
        private string _creditcardapprovalcode;
        private Int32? _currencyrateid;
        private decimal _subtotal;
        private decimal _taxamt;
        private decimal _freight;
        private decimal _totaldue;
        private string _comment;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "SalesOrderID")]
        public Int32 Salesorderid
        {
            get { return _salesorderid; }
            set { _salesorderid = value; }
        }

        [Column(Name = "RevisionNumber", Required = true)]
        public Int16 Revisionnumber
        {
            get { return _revisionnumber; }
            set { _revisionnumber = value; }
        }

        [Column(Name = "OrderDate", Required = true)]
        public DateTime Orderdate
        {
            get { return _orderdate; }
            set { _orderdate = value; }
        }

        [Column(Name = "DueDate", Required = true)]
        public DateTime Duedate
        {
            get { return _duedate; }
            set { _duedate = value; }
        }

        [Column(Name = "ShipDate", Required = false)]
        public DateTime? Shipdate
        {
            get { return _shipdate; }
            set { _shipdate = value; }
        }

        [Column(Name = "Status", Required = true)]
        public Int16 Status
        {
            get { return _status; }
            set { _status = value; }
        }

        [Column(Name = "OnlineOrderFlag", Required = true)]
        public bool Onlineorderflag
        {
            get { return _onlineorderflag; }
            set { _onlineorderflag = value; }
        }

        [Id(Name = "SalesOrderNumber")]
        public string Salesordernumber
        {
            get { return _salesordernumber; }
            set { _salesordernumber = value; }
        }

        [Column(Name = "PurchaseOrderNumber", Required = false)]
        public string Purchaseordernumber
        {
            get { return _purchaseordernumber; }
            set { _purchaseordernumber = value; }
        }

        [Column(Name = "AccountNumber", Required = false)]
        public string Accountnumber
        {
            get { return _accountnumber; }
            set { _accountnumber = value; }
        }

        [Id(Name = "CustomerID")]
        public Int32 Customerid
        {
            get { return _customerid; }
            set { _customerid = value; }
        }

        [Column(Name = "ContactID", Required = true)]
        public Int32 Contactid
        {
            get { return _contactid; }
            set { _contactid = value; }
        }

        [Id(Name = "SalesPersonID")]
        public Int32? Salespersonid
        {
            get { return _salespersonid; }
            set { _salespersonid = value; }
        }

        [Column(Name = "TerritoryID", Required = false)]
        public Int32? Territoryid
        {
            get { return _territoryid; }
            set { _territoryid = value; }
        }

        [Column(Name = "BillToAddressID", Required = true)]
        public Int32 Billtoaddressid
        {
            get { return _billtoaddressid; }
            set { _billtoaddressid = value; }
        }

        [Column(Name = "ShipToAddressID", Required = true)]
        public Int32 Shiptoaddressid
        {
            get { return _shiptoaddressid; }
            set { _shiptoaddressid = value; }
        }

        [Column(Name = "ShipMethodID", Required = true)]
        public Int32 Shipmethodid
        {
            get { return _shipmethodid; }
            set { _shipmethodid = value; }
        }

        [Column(Name = "CreditCardID", Required = false)]
        public Int32? Creditcardid
        {
            get { return _creditcardid; }
            set { _creditcardid = value; }
        }

        [Column(Name = "CreditCardApprovalCode", Required = false)]
        public string Creditcardapprovalcode
        {
            get { return _creditcardapprovalcode; }
            set { _creditcardapprovalcode = value; }
        }

        [Column(Name = "CurrencyRateID", Required = false)]
        public Int32? Currencyrateid
        {
            get { return _currencyrateid; }
            set { _currencyrateid = value; }
        }

        [Column(Name = "SubTotal", Required = true)]
        public decimal Subtotal
        {
            get { return _subtotal; }
            set { _subtotal = value; }
        }

        [Column(Name = "TaxAmt", Required = true)]
        public decimal Taxamt
        {
            get { return _taxamt; }
            set { _taxamt = value; }
        }

        [Column(Name = "Freight", Required = true)]
        public decimal Freight
        {
            get { return _freight; }
            set { _freight = value; }
        }

        [Column(Name = "TotalDue", Required = true)]
        public decimal Totaldue
        {
            get { return _totaldue; }
            set { _totaldue = value; }
        }

        [Column(Name = "Comment", Required = false)]
        public string Comment
        {
            get { return _comment; }
            set { _comment = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.SalesOrderHeaderSalesReason")]
    public class Salesorderheadersalesreason
    {
        private Int32 _salesorderid;
        private Int32 _salesreasonid;
        private DateTime _modifieddate;

        [Id(Name = "SalesOrderID")]
        public Int32 Salesorderid
        {
            get { return _salesorderid; }
            set { _salesorderid = value; }
        }

        [Id(Name = "SalesReasonID")]
        public Int32 Salesreasonid
        {
            get { return _salesreasonid; }
            set { _salesreasonid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.SalesPerson")]
    public class Salesperson
    {
        private Int32 _salespersonid;
        private Int32? _territoryid;
        private decimal _salesquota;
        private decimal _bonus;
        private decimal _commissionpct;
        private decimal _salesytd;
        private decimal _saleslastyear;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "SalesPersonID")]
        public Int32 Salespersonid
        {
            get { return _salespersonid; }
            set { _salespersonid = value; }
        }

        [Column(Name = "TerritoryID", Required = false)]
        public Int32? Territoryid
        {
            get { return _territoryid; }
            set { _territoryid = value; }
        }

        [Column(Name = "SalesQuota", Required = false)]
        public decimal Salesquota
        {
            get { return _salesquota; }
            set { _salesquota = value; }
        }

        [Column(Name = "Bonus", Required = true)]
        public decimal Bonus
        {
            get { return _bonus; }
            set { _bonus = value; }
        }

        [Column(Name = "CommissionPct", Required = true)]
        public decimal Commissionpct
        {
            get { return _commissionpct; }
            set { _commissionpct = value; }
        }

        [Column(Name = "SalesYTD", Required = true)]
        public decimal Salesytd
        {
            get { return _salesytd; }
            set { _salesytd = value; }
        }

        [Column(Name = "SalesLastYear", Required = true)]
        public decimal Saleslastyear
        {
            get { return _saleslastyear; }
            set { _saleslastyear = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.SalesPersonQuotaHistory")]
    public class Salespersonquotahistory
    {
        private Int32 _salespersonid;
        private DateTime _quotadate;
        private decimal _salesquota;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "SalesPersonID")]
        public Int32 Salespersonid
        {
            get { return _salespersonid; }
            set { _salespersonid = value; }
        }

        [Id(Name = "QuotaDate")]
        public DateTime Quotadate
        {
            get { return _quotadate; }
            set { _quotadate = value; }
        }

        [Column(Name = "SalesQuota", Required = true)]
        public decimal Salesquota
        {
            get { return _salesquota; }
            set { _salesquota = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.SalesReason")]
    public class Salesreason
    {
        private Int32 _salesreasonid;
        private string _name;
        private string _reasontype;
        private DateTime _modifieddate;

        [Id(Name = "SalesReasonID")]
        public Int32 Salesreasonid
        {
            get { return _salesreasonid; }
            set { _salesreasonid = value; }
        }

        [Column(Name = "Name", Required = true)]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Column(Name = "ReasonType", Required = true)]
        public string Reasontype
        {
            get { return _reasontype; }
            set { _reasontype = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.SalesTaxRate")]
    public class Salestaxrate
    {
        private Int32 _salestaxrateid;
        private Int32 _stateprovinceid;
        private Int16 _taxtype;
        private decimal _taxrate;
        private string _name;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "SalesTaxRateID")]
        public Int32 Salestaxrateid
        {
            get { return _salestaxrateid; }
            set { _salestaxrateid = value; }
        }

        [Id(Name = "StateProvinceID")]
        public Int32 Stateprovinceid
        {
            get { return _stateprovinceid; }
            set { _stateprovinceid = value; }
        }

        [Id(Name = "TaxType")]
        public Int16 Taxtype
        {
            get { return _taxtype; }
            set { _taxtype = value; }
        }

        [Column(Name = "TaxRate", Required = true)]
        public decimal Taxrate
        {
            get { return _taxrate; }
            set { _taxrate = value; }
        }

        [Column(Name = "Name", Required = true)]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.SalesTerritory")]
    public class Salesterritory
    {
        private Int32 _territoryid;
        private string _name;
        private string _countryregioncode;
        private string _group;
        private decimal _salesytd;
        private decimal _saleslastyear;
        private decimal _costytd;
        private decimal _costlastyear;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "TerritoryID")]
        public Int32 Territoryid
        {
            get { return _territoryid; }
            set { _territoryid = value; }
        }

        [Id(Name = "Name")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Column(Name = "CountryRegionCode", Required = true)]
        public string Countryregioncode
        {
            get { return _countryregioncode; }
            set { _countryregioncode = value; }
        }

        [Column(Name = "Group", Required = true)]
        public string Group
        {
            get { return _group; }
            set { _group = value; }
        }

        [Column(Name = "SalesYTD", Required = true)]
        public decimal Salesytd
        {
            get { return _salesytd; }
            set { _salesytd = value; }
        }

        [Column(Name = "SalesLastYear", Required = true)]
        public decimal Saleslastyear
        {
            get { return _saleslastyear; }
            set { _saleslastyear = value; }
        }

        [Column(Name = "CostYTD", Required = true)]
        public decimal Costytd
        {
            get { return _costytd; }
            set { _costytd = value; }
        }

        [Column(Name = "CostLastYear", Required = true)]
        public decimal Costlastyear
        {
            get { return _costlastyear; }
            set { _costlastyear = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.SalesTerritoryHistory")]
    public class Salesterritoryhistory
    {
        private Int32 _salespersonid;
        private Int32 _territoryid;
        private DateTime _startdate;
        private DateTime? _enddate;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "SalesPersonID")]
        public Int32 Salespersonid
        {
            get { return _salespersonid; }
            set { _salespersonid = value; }
        }

        [Id(Name = "TerritoryID")]
        public Int32 Territoryid
        {
            get { return _territoryid; }
            set { _territoryid = value; }
        }

        [Id(Name = "StartDate")]
        public DateTime Startdate
        {
            get { return _startdate; }
            set { _startdate = value; }
        }

        [Column(Name = "EndDate", Required = false)]
        public DateTime? Enddate
        {
            get { return _enddate; }
            set { _enddate = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.ShoppingCartItem")]
    public class Shoppingcartitem
    {
        private Int32 _shoppingcartitemid;
        private string _shoppingcartid;
        private Int32 _quantity;
        private Int32 _productid;
        private DateTime _datecreated;
        private DateTime _modifieddate;

        [Id(Name = "ShoppingCartItemID")]
        public Int32 Shoppingcartitemid
        {
            get { return _shoppingcartitemid; }
            set { _shoppingcartitemid = value; }
        }

        [Id(Name = "ShoppingCartID")]
        public string Shoppingcartid
        {
            get { return _shoppingcartid; }
            set { _shoppingcartid = value; }
        }

        [Column(Name = "Quantity", Required = true)]
        public Int32 Quantity
        {
            get { return _quantity; }
            set { _quantity = value; }
        }

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Column(Name = "DateCreated", Required = true)]
        public DateTime Datecreated
        {
            get { return _datecreated; }
            set { _datecreated = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.SpecialOffer")]
    public class Specialoffer
    {
        private Int32 _specialofferid;
        private string _description;
        private decimal _discountpct;
        private string _type;
        private string _category;
        private DateTime _startdate;
        private DateTime _enddate;
        private Int32 _minqty;
        private Int32? _maxqty;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "SpecialOfferID")]
        public Int32 Specialofferid
        {
            get { return _specialofferid; }
            set { _specialofferid = value; }
        }

        [Column(Name = "Description", Required = true)]
        public string Description
        {
            get { return _description; }
            set { _description = value; }
        }

        [Column(Name = "DiscountPct", Required = true)]
        public decimal Discountpct
        {
            get { return _discountpct; }
            set { _discountpct = value; }
        }

        [Column(Name = "Type", Required = true)]
        public string Type
        {
            get { return _type; }
            set { _type = value; }
        }

        [Column(Name = "Category", Required = true)]
        public string Category
        {
            get { return _category; }
            set { _category = value; }
        }

        [Column(Name = "StartDate", Required = true)]
        public DateTime Startdate
        {
            get { return _startdate; }
            set { _startdate = value; }
        }

        [Column(Name = "EndDate", Required = true)]
        public DateTime Enddate
        {
            get { return _enddate; }
            set { _enddate = value; }
        }

        [Column(Name = "MinQty", Required = true)]
        public Int32 Minqty
        {
            get { return _minqty; }
            set { _minqty = value; }
        }

        [Column(Name = "MaxQty", Required = false)]
        public Int32? Maxqty
        {
            get { return _maxqty; }
            set { _maxqty = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.SpecialOfferProduct")]
    public class Specialofferproduct
    {
        private Int32 _specialofferid;
        private Int32 _productid;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "SpecialOfferID")]
        public Int32 Specialofferid
        {
            get { return _specialofferid; }
            set { _specialofferid = value; }
        }

        [Id(Name = "ProductID")]
        public Int32 Productid
        {
            get { return _productid; }
            set { _productid = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.Store")]
    public class Store
    {
        private Int32 _customerid;
        private string _name;
        private Int32? _salespersonid;
        private string _demographics;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "CustomerID")]
        public Int32 Customerid
        {
            get { return _customerid; }
            set { _customerid = value; }
        }

        [Column(Name = "Name", Required = true)]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Id(Name = "SalesPersonID")]
        public Int32? Salespersonid
        {
            get { return _salespersonid; }
            set { _salespersonid = value; }
        }

        [Id(Name = "Demographics")]
        public string Demographics
        {
            get { return _demographics; }
            set { _demographics = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
    [Serializable]
    [Table(TableName = "Sales.StoreContact")]
    public class Storecontact
    {
        private Int32 _customerid;
        private Int32 _contactid;
        private Int32 _contacttypeid;
        private object _rowguid;
        private DateTime _modifieddate;

        [Id(Name = "CustomerID")]
        public Int32 Customerid
        {
            get { return _customerid; }
            set { _customerid = value; }
        }

        [Id(Name = "ContactID")]
        public Int32 Contactid
        {
            get { return _contactid; }
            set { _contactid = value; }
        }

        [Id(Name = "ContactTypeID")]
        public Int32 Contacttypeid
        {
            get { return _contacttypeid; }
            set { _contacttypeid = value; }
        }

        [Id(Name = "rowguid")]
        public object Rowguid
        {
            get { return _rowguid; }
            set { _rowguid = value; }
        }

        [Column(Name = "ModifiedDate", Required = true)]
        public DateTime Modifieddate
        {
            get { return _modifieddate; }
            set { _modifieddate = value; }
        }

    }
}